=== debian/changelog ===
globjects (1.0.0-2) unstable; urgency=medium

  * Fix packaging testsuite failure.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 25 Nov 2016 11:32:31 +0000

globjects (1.0.0-1) unstable; urgency=medium

  * New upstream version 1.0.0
  * Refresh patch queue.
  * Upgrade packaging to debhelper 10.
  * Bump soname of shared library packages.
  * Update upstream copyright.
  * Release to unstable.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Mon, 21 Nov 2016 12:11:55 +0000

globjects (0.5.0-1) experimental; urgency=low

  * Initial release. (Closes: #837464)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 17 Sep 2016 16:51:56 +0100
