=== debian/control ===
Source: globjects
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Testsuite: autopkgtest
Priority: optional
Build-Depends: cmake (>= 3.0),
               debhelper (>= 10),
               libglbinding-dev,
               libglm-dev 
Build-Depends-Indep: doxygen
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/globjects.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/globjects.git
Homepage: https://github.com/cginternals/globjects

Package: libglobjects1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: cross-platform C++ wrapper for OpenGL API objects
 globjects provides object-oriented interfaces to the OpenGL API (3.0 and
 higher). The main goals are much reduced code to use OpenGL in your
 rendering software and fewer errors due to the underlying glbinding and
 further abstraction levels on top. Typical processes are automated and
 missing features in the used OpenGL driver are partially simulated or
 even emulated.
 .
 This package provides the shared libraries.

Package: libglobjects-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libglbinding-dev,
         libglobjects1 (= ${binary:Version})
Suggests: globjects-doc
Description: development files for globjects
 globjects provides object-oriented interfaces to the OpenGL API (3.0 and
 higher). The main goals are much reduced code to use OpenGL in your
 rendering software and fewer errors due to the underlying glbinding and
 further abstraction levels on top. Typical processes are automated and
 missing features in the used OpenGL driver are partially simulated or
 even emulated.
 .
 This package provides the development files.

Package: globjects-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         fonts-font-awesome,
         libjs-bootstrap,
         libjs-jquery
Description: documentation for globjects
 globjects provides object-oriented interfaces to the OpenGL API (3.0 and
 higher). The main goals are much reduced code to use OpenGL in your
 rendering software and fewer errors due to the underlying glbinding and
 further abstraction levels on top. Typical processes are automated and
 missing features in the used OpenGL driver are partially simulated or
 even emulated.
 .
 This package provides the documentation.
