=== debian/tests/control ===
Tests: globjects-tests
Depends: @, cmake, g++ | c++-compiler
