=== debian/changelog ===
globjects (1.1.0-3build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:04:20 +0100

globjects (1.1.0-3) unstable; urgency=medium

  * Team upload
  * Allow output to stderr, because of new cmake complaining
    wrt CMP0037 being deprecated

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 04 Jul 2018 10:51:56 +0200

globjects (1.1.0-2) unstable; urgency=medium

  * Bump standards version to 4.0.0, no changes required
  * Add support for the nodoc build profile
  * Release to unstable

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 20 Jul 2017 09:42:26 +0100

globjects (1.1.0-1) experimental; urgency=medium

  * New upstream version 1.1.0
  * Fixup the Vcs-Browser URI
  * Release to experimental

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 21 Mar 2017 15:36:59 +0000
