=== debian/control ===
--- 
+++ 
@@ -6,11 +6,12 @@
 Priority: optional
 Build-Depends: cmake (>= 3.0),
                debhelper (>= 10),
+               dpkg-dev (>= 1.17.14),
                libglbinding-dev,
-               libglm-dev 
-Build-Depends-Indep: doxygen
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/globjects.git
+               libglm-dev
+Build-Depends-Indep: doxygen <!nodoc>
+Standards-Version: 4.0.0
+Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/globjects.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/globjects.git
 Homepage: https://github.com/cginternals/globjects
 
@@ -37,7 +38,7 @@
 Depends: ${misc:Depends},
          libglbinding-dev,
          libglobjects1 (= ${binary:Version})
-Suggests: globjects-doc
+Suggests: globjects-doc <!nodoc>
 Description: development files for globjects
  globjects provides object-oriented interfaces to the OpenGL API (3.0 and
  higher). The main goals are much reduced code to use OpenGL in your
@@ -65,3 +66,4 @@
  even emulated.
  .
  This package provides the documentation.
+Build-Profiles: <!nodoc>
