=== debian/rules ===
--- 
+++ 
@@ -26,8 +26,12 @@
 	dh_auto_configure -- $(BUILD_OPTIONS) -DOPTION_BUILD_DOCS=OFF
 
 override_dh_auto_configure-indep:
+ifeq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
 	dh_auto_configure -- $(BUILD_OPTIONS) -DOPTION_BUILD_DOCS=ON
+endif
 
 override_dh_installdocs-indep:
 	dh_installdocs --indep
+ifeq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
 	dh_doxygen --indep
+endif
